#include "jserver.h"

#define PHASE_INIT 0
#define PHASE_HEAD 1
#define PHASE_BODY 2
#define PHASE_DONE 3

#define MIME_HTML 0
#define MIME_JS 1
#define MIME_XML 2
#define MIME_GIF 3
#define MIME_TXT 4

/* our 'session' data */
typedef struct hrq_struct
{
    int phase, clen, rn, re_code, re_flag;
    char *ip;
    session s;
    jid id;
    thread t;
    xmlnode x, re;
    pool p;
} *hrq, _hrq;

void svc_http_qs2xml(xmlnode x, char *qs);
void svc_http_strdecode(char *from);
void svc_http_error(hrq rq, int err);
void svc_http_redirect(hrq rq, char *url);
void svc_http_reply_mime(hrq rq, int type);
void svc_http_reply_append(hrq rq, ...);
void svc_http_reply(hrq rq);

void svc_http_public_init(void);
